
#pragma varargck type "E" int
#pragma varargck type "S" int

/* bits.s */
void linux_sigreturn(void);
void linux_rtsigreturn(void);
void jumpureg(void *ureg);
void incref(Ref *);
int decref(Ref *);

/* CUT-HERE */
/* bufproc.c */
void freebufproc(void *bp);
void *newbufproc(int fd);
int readbufproc(void *bp, void *data, int len, int peek, int noblock);
int pollbufproc(void *bp, Ufile *file, void *tab);
int nreadablebufproc(void *bp);

/* consdev.c */
void flusher(void *arg);
int isaconsole(int fd);
void consdevinit(void);

/* dspdev.c */
void dspdevinit(void);

/* error.c */
int Efmt(Fmt *f);
int mkerror(void);
void kprint(char *fmt, ...);

/* etcdev.c */
void etcdevinit(void);

/* exec.c */
int sys_execve(char *path, char *argv[], char *envp[]);

/* fb.c */
Framebuffer *fb_open(void **fbmem, ulong *fbsiz);
int fb_read(Framebuffer *fb, void *buf, int len, vlong off);
int fb_write(Framebuffer *fb, void *buf, int len, vlong off);
int fb_getvarinfo(Framebuffer *fb, void *arg);
int fb_putvarinfo(Framebuffer *fb, void *arg);
int fb_getfixinfo(Framebuffer *fb, char *arg);
int fb_close(Framebuffer *fb);

/* file.c */
Ufile *getfile(Ufile *file);
void putfile(Ufile *file);
Ufile *procfdgetfile(Uproc *proc, int fd);
Ufile *fdgetfile(int fd);
int newfd(Ufile *file, int flags);
int sys_dup2(int old, int new);
int sys_dup(int fd);
int sys_fcntl(int fd, int cmd, int arg);
int sys_close(int fd);
int sys_ioctl(int fd, int cmd, void *arg);
int preadfile(Ufile *file, void *buf, int len, vlong off);
int readfile(Ufile *file, void *buf, int len);
int pwritefile(Ufile *file, void *buf, int len, vlong off);
int writefile(Ufile *file, void *buf, int len);
int sys_read(int fd, void *buf, int len);
int sys_write(int fd, void *buf, int len);
int sys_pread64(int fd, void *buf, int len, ulong off);
int sys_pwrite64(int fd, void *buf, int len, ulong off);
int sys_writev(int fd, void *vec, int n);
int sys_readv(int fd, void *vec, int n);
int seekfile(Ufile *file, vlong off, int whence);
ulong sys_lseek(int fd, ulong off, int whence);
int sys_llseek(int fd, ulong hioff, ulong looff, vlong *res, int whence);
int sys_umask(int umask);
int chdirfile(Ufile *f);
int sys_fchdir(int fd);
int sys_fchown(int fd, int uid, int gid);
int sys_fchmod(int fd, int mode);
int sys_ftruncate(int fd, ulong size);
void initfile(void);
void exitfile(Uproc *proc);
void clonefile(Uproc *new, int copy);
void closexfds(void);

/* fs.c */
void fsmount(Udev *dev, char *path);
char *mounts(void);
void devdirinit(void);
ulong hashpath(char *s);
char *basepath(char *p, char **ps);
char *allocpath(char *base, char *prefix, char *name);
char *fullpath(char *base, char *name);
int fsfullpath(char **path, int check);
int sys_getcwd(char *buf, int len);
int fsaccess(char *path, int mode);
int do_faccess(char *path, int mode, int flags);
int sys_access(char *path, int mode);
int fsopen(char *path, int mode, int perm, Ufile **pf);
int sys_open(char *path, int omode, int perm);
int sys_creat(char *path, int perm);
int fsstat(char *path, int link, Ustat *ps);
int sys_chdir(char *path);
int sys_chroot(char *path);
int fschown(char *path, int uid, int gid, int link);
int sys_chown(char *path, int uid, int gid);
int sys_lchown(char *path, int uid, int gid);
int fsreadlink(char *path, char *buf, int len);
int sys_readlink(char *path, char *buf, int len);
int fsrename(char *old, char *new);
int sys_rename(char *from, char *to);
int fsmkdir(char *path, int mode);
int sys_mkdir(char *path, int mode);
int fsutime(char *path, int atime, int mtime);
int sys_utime(char *path, void *times);
int sys_utimes(char *path, void *tvp);
int fschmod(char *path, int mode, int link);
int sys_chmod(char *path, int mode);
int sys_lchmod(char *path, int mode);
int fstruncate(char *path, vlong size);
int sys_truncate(char *path, ulong size);
int fsunlink(char *path, int rmdir);
int sys_unlink(char *path);
int sys_rmdir(char *path);
int fslink(char *old, char *new, int sym);
int sys_link(char *old, char *new);
int sys_symlink(char *old, char *new);
int fsmknod(char *path, int mode, int devnum);
int sys_mknod(char *path, int mode, int dev);
int sys_openat(int fd, char *path, int flags, int mode);
int sys_unlinkat(int fd, char *path, int flags);
int sys_mkdirat(int fd, char *path, int mode);
int sys_renameat(int oldfd, char *oldpath, char *newpath);
int sys_linkat(int oldfd, char *oldpath, int newfd, char *newpath, int flags);
int sys_futimesat(int fd, char *path, void *times);
int sys_fstatat64(int fd, char *path, void *sb, int flags);
int sys_readlinkat(int fd, char *path, void *buf, int len);
int sys_fchownat(int fd, char *path, int uid, int gid, int flags);
int sys_fchmodat(int fd, char *path, int mode, int flags);
int sys_symlinkat(char *old, int fd, char *new);
int sys_faccessat(int fd, char *path, int mode, int flags);

/* linuxcall.c */
void linuxcall(void);
int _kernel_vsyscall(uint idx, uint a1, uint a2, uint a3, uint a4, uint a5, uint a6);
char *syscallstats(void);

/* main.c */
int onstack(long *stk, int (*func )(void *), void *arg);
void profme(void);
int setlabel(char **argv);
void panic(char *msg, ...);
void main(int argc, char *argv[]);

/* mem.c */
void *kmalloc(int size);
void *krealloc(void *ptr, int size);
void *kmallocz(int size, int zero);
char *kstrdup(char *s);
char *ksmprint(char *fmt, ...);
ulong pagealign(ulong addr);
int okaddr(void *ptr, int len, int write);
void *mapstack(int size);
void mapdata(ulong base);
void unmapuserspace(void);
void initmem(void);
void exitmem(void);
void clonemem(Uproc *new, int copy);
ulong procmemstat(Uproc *proc, ulong *pdat, ulong *plib, ulong *pshr, ulong *pstk, ulong *pexe);
ulong sys_linux_mmap(void *a);
ulong sys_mmap(ulong addr, ulong len, int prot, int flags, int fd, ulong pgoff);
int sys_munmap(ulong addr, ulong len);
ulong sys_brk(ulong bk);
int sys_mprotect(ulong addr, ulong len, int prot);
int sys_msync(ulong addr, ulong len, int flags);
ulong sys_mremap(ulong addr, ulong oldlen, ulong newlen, int flags, ulong newaddr);
int sys_futex(ulong *addr, int op, int val, void *ptime, ulong *addr2, int val3);

/* miscdev.c */
void miscdevinit(void);

/* netlink.c */
int nl_write(Socket *sock, void *buf, int len, vlong off);
int nl_read(Socket *sock, void *buf, int len, vlong off);

/* new-sockdev.c */
int sys_linux_socketcall(int call, int *arg);
void sockdevinit(void);

/* pathcache.c */
void updatecache(int err, char *path, char *dest);
int lookcache(char **path, int check);
int flushcache(char *path);
char *cacheentries(void);
int retry(int err, char **path, int check);

/* pipedev.c */
int pipewrite(int fd, void *buf, int len);
int sys_pipe(int fds[2 ]);
int sys_pipe2(int fds[2 ], int flags);
void pipedevinit(void);

/* poll.c */
void pollwait(Ufile *f, Uwaitq *q, void *t);
int sys_poll(void *p, int nfd, long timeout);
int sys_select(int nfd, ulong *rfd, ulong *wfd, ulong *efd, void *ptv);
int sys_pselect(int nfd, ulong *rfd, ulong *wfd, ulong *efd, void *tout, void *sigs);

/* proc.c */
Uproc *getproc(int tid);
Uproc *getprocn(int n);
void initproc(char *root);
void setprocname(char *s);
int procfork(void (*func )(void *aux ), void *aux, int flags);
int notifyme(int on);
void wakeme(int on);
int sleepproc(QLock *l, int flags);
Uwait *addwaitq(Uwaitq *q);
void delwaitq(Uwait *w);
int requeue(Uwaitq *q1, Uwaitq *q2, int nrequeue);
int wakeq(Uwaitq *q, int nwake);
int sleepq(Uwaitq *q, QLock *l, int flags);
int procsetalarm(Uproc *proc, vlong t);
void setalarm(vlong t);
int sys_waitpid(int pid, int *pexit, int opt);
int sys_wait4(int pid, int *pexit, int opt, void *prusage);
int sys_getrusage(int who, void *prusage);
int threadcount(int pid);
int killproc(Uproc *p, Usiginfo *info, int group);
void zapthreads(void);
void exitproc(Uproc *proc, int code, int group);
void stopproc(Uproc *proc, int code, int group);
void contproc(Uproc *proc, int code, int group);
int sys_exit(int code);
int sys_exit_group(int code);
int sys_linux_clone(int flags, void *newstack, int *parenttidptr, int *tlsdescr, void *childtidptr);
int sys_fork(void);
int sys_vfork(void);
int sys_getpid(void);
int sys_getppid(void);
int sys_gettid(void);
int sys_setpgid(int pid, int pgid);
int sys_getpgid(int pid);
int sys_getpgrp(void);
int sys_getuid(void);
int sys_getgid(void);
int sys_setuid(int uid);
int sys_setgid(int gid);
int sys_getresuid(int *ruid, int *euid, int *suid);
int sys_getresgid(int *rgid, int *egid, int *sgid);
int sys_setsid(void);
int sys_getsid(int pid);
int sys_uname(void *a);
int sys_tkill(int tid, int sig);
int sys_tgkill(int pid, int tid, int sig);
int sys_rt_sigqueueinfo(int pid, int sig, void *info);
int sys_kill(int pid, int sig);
int sys_set_tid_address(int *tidptr);
int sys_sched_getparam(int pid, void *param);
int sys_sched_yield(void);
int sys_getrlimit(long resource, void *rlim);
int sys_ugetrlimit(long resource, void *rlim);
int sys_prctl(int cmd, long arg1, long arg2, long arg3, long arg4);
int sys_ptrace(int cmd, int pid, void *addr, void *data);
long sys_sched_get_priority_max(int policy);
long sys_sched_get_priority_min(int policy);

/* procdev.c */
int sys_sysinfo(void *buf);
void procdevinit(char *root);

/* ptydev.c */
void ttyinfo(Uproc *pr, int *ttynum, int *ttygrp);
void ptydevinit(void);

/* rootdev.c */
void hllink(char *rold, char *rnew);
void hlunlink(char *rpath);
int hlnlink(char *rpath);
void rootdevinit(char *root);

/* signal.c */
void initsignal(void);
void exitsignal(void);
void clonesignal(Uproc *new, int copyhand, int newproc);
void settty(Uproc *pr, Ufile *tty);
Ufile *gettty(Uproc *pr);
int ignoressignal(Uproc *proc, int sig);
int wantssignal(Uproc *proc, int sig);
int sendsignal(Uproc *proc, Usiginfo *info, int group);
int signalspending(Uproc *proc);
void linux2siginfo(void *p, Usiginfo *info);
int sys_sigreturn(void);
int sys_rt_sigreturn(void);
void handlesignals(void);
int sys_rt_sigsuspend(uchar *set, int setsize);
int sys_sigaltstack(void *stk, void *ostk);
int sys_rt_sigaction(int sig, void *pact, void *poact, int setsize);
int sys_rt_sigpending(uchar *set, int setsize);
int sys_rt_sigprocmask(int how, uchar *act, uchar *oact, int setsize);
int sys_setitimer(int which, void *value, void *ovalue);
int sys_getitimer(int which, void *value);
int sys_alarm(long seconds);
int Sfmt(Fmt *f);
void alarmtimer(Uproc *proc, vlong now);

/* sockdev.c */
int sys_linux_socketcall(int call, int *arg);
void sockdevinit(void);

/* stat.c */
int ufstat(int fd, Ustat *ps);
int sys_linux_stat(char *path, void *st);
int sys_linux_lstat(char *path, void *st);
int sys_linux_stat64(char *path, void *st);
int sys_linux_lstat64(char *path, void *st);
int sys_linux_fstat(int fd, void *st);
int sys_linux_fstat64(int fd, void *st);
Udirent *newdirent(char *name, int mode, int ino);
int mkino(int qpath, int iter);
int sys_linux_getdents(int fd, void *buf, int nbuf);
int sys_linux_getdents64(int fd, void *buf, int nbuf);
int sys_statfs(char *path, void *pstatfs);
int sys_fstatfs(int fd, void *pstatfs);
int sys_statfs64(char *path, int len, void *pstatfs);
int sys_fstatfs64(int fd, int len, void *pstatfs);

/* time.c */
void inittime(void);
int sys_time(long *p);
int sys_clock_gettime(int clock, void *t);
int sys_gettimeofday(void *tvp, void *tzp);
int sys_nanosleep(void *rqp, void *rmp);
int proctimes(Uproc *p, ulong *t);
int sys_times(void *m);

/* tls.c */
int sys_set_thread_area(void *pinfo);
int sys_get_thread_area(void *pinfo);
void inittls(void);
void clonetls(Uproc *new);

/* trace.c */
void inittrace(void);
void exittrace(Uproc *proc);
void clonetrace(Uproc *new, int copy);
void trace(char *fmt, ...);

/* trap.c */
void retuser(void);
void inittrap(void);

